searchData={"items":[{"type":"module","title":"Pythonx","doc":"Documentation for `Pythonx`.","ref":"Pythonx.html"},{"type":"function","title":"Pythonx.eval/2","doc":"","ref":"Pythonx.html#eval/2"},{"type":"function","title":"Pythonx.eval!/2","doc":"","ref":"Pythonx.html#eval!/2"},{"type":"function","title":"Pythonx.finalize/0","doc":"","ref":"Pythonx.html#finalize/0"},{"type":"function","title":"Pythonx.initialize/0","doc":"","ref":"Pythonx.html#initialize/0"},{"type":"function","title":"Pythonx.initialize/1","doc":"Initializes the Python with the given path to `python_home`.\n\nThis function must be called before any other function in this module.\n\nIt's expected that the `python_home` is the path to the python3 directory, which contains the following\ndirectories and files:\n\n```bash\n- bin\n  - python3\n  - python3.x\n- include\n- lib\n  - python3.x\n  - libpython3.x.so (on Linux)\n  - libpython3.x.dylib (on macOS)\n```\n\nIt's also expected that this function to be called only once, and it must be called before any other function.","ref":"Pythonx.html#initialize/1"},{"type":"function","title":"Pythonx.initialize_once/1","doc":"","ref":"Pythonx.html#initialize_once/1"},{"type":"function","title":"Pythonx.inline/2","doc":"","ref":"Pythonx.html#inline/2"},{"type":"function","title":"Pythonx.inline!/2","doc":"","ref":"Pythonx.html#inline!/2"},{"type":"function","title":"Pythonx.list_python_versions/0","doc":"List all embedded python versions.","ref":"Pythonx.html#list_python_versions/0"},{"type":"macro","title":"Pythonx.pip!/2","doc":"Executes a command with the embedded pip module.","ref":"Pythonx.html#pip!/2"},{"type":"macro","title":"Pythonx.pyeval/2","doc":"Evaluates the given python code and returns the variables specified in the `return` option.","ref":"Pythonx.html#pyeval/2"},{"type":"macro","title":"Pythonx.pyinline/2","doc":"","ref":"Pythonx.html#pyinline/2"},{"type":"macro","title":"Pythonx.python3!/2","doc":"Executes a command with the embedded python3 executable.","ref":"Pythonx.html#python3!/2"},{"type":"function","title":"Pythonx.python3_executable/0","doc":"Returns the path to the python3 executable.","ref":"Pythonx.html#python3_executable/0"},{"type":"function","title":"Pythonx.python_home/0","doc":"Returns the value for `PYTHONHOME`.","ref":"Pythonx.html#python_home/0"},{"type":"module","title":"Pythonx.C.PyErr","doc":"Python Exception","ref":"Pythonx.C.PyErr.html"},{"type":"type","title":"Pythonx.C.PyErr.t/0","doc":"","ref":"Pythonx.C.PyErr.html#t:t/0"},{"type":"module","title":"Pythonx.C.PyList","doc":"This subtype of PyObject represents a Python list object.","ref":"Pythonx.C.PyList.html"},{"type":"function","title":"Pythonx.C.PyList.append/2","doc":"Append the object item at the end of list list.\n\nReturn true if successful; return `PyErr` with an exception if unsuccessful.\n\nAnalogous to list.append(item).","ref":"Pythonx.C.PyList.html#append/2"},{"type":"function","title":"Pythonx.C.PyList.as_tuple/1","doc":"Return a new tuple object containing the contents of `list`;\n\nequivalent to `tuple(list)`.\n\nReturn value: New reference","ref":"Pythonx.C.PyList.html#as_tuple/1"},{"type":"function","title":"Pythonx.C.PyList.check/1","doc":"Return true if `p` is a list object or an instance of a subtype of the list type.\n\nThis function always succeeds.","ref":"Pythonx.C.PyList.html#check/1"},{"type":"function","title":"Pythonx.C.PyList.check_exact/1","doc":"Return true if `p` is a list object, but not an instance of a subtype of the list type.\n\nThis function always succeeds.","ref":"Pythonx.C.PyList.html#check_exact/1"},{"type":"function","title":"Pythonx.C.PyList.get_item/2","doc":"Return the object at position index in the list pointed to by list.\n\nThe position must be non-negative; indexing from the end of the list is not supported.\n\nIf index is out of bounds (<0 or >=len(list)), return `PyErr`\n\nReturn value: Borrowed reference.","ref":"Pythonx.C.PyList.html#get_item/2"},{"type":"function","title":"Pythonx.C.PyList.get_slice/3","doc":"Return a list of the objects in `list` containing the objects between `low` and `high`.\n\nReturn `PyErr` with an exception if unsuccessful.\n\nAnalogous to `list[low:high]`.\n\nIndexing from the end of the list is not supported.\n\nReturn value: New reference.","ref":"Pythonx.C.PyList.html#get_slice/3"},{"type":"function","title":"Pythonx.C.PyList.insert/3","doc":"Insert the item item into list `list` in front of index index.\n\nReturn `true` if successful; return `PyErr` with an exception if unsuccessful.\n\nAnalogous to list.insert(index, item).","ref":"Pythonx.C.PyList.html#insert/3"},{"type":"function","title":"Pythonx.C.PyList.new/1","doc":"Return a new list of length len on success, or `PyErr` on failure.","ref":"Pythonx.C.PyList.html#new/1"},{"type":"function","title":"Note - Pythonx.C.PyList.new/1","doc":"If len is greater than zero, the returned list object’s items are set to NULL.\nThus you cannot use abstract API functions such as PySequence_SetItem() or expose\nthe object to Python code before setting all items to a real object with PyList_SetItem().\n\nReturn value: New reference.","ref":"Pythonx.C.PyList.html#new/1-note"},{"type":"function","title":"Pythonx.C.PyList.reverse/1","doc":"Reverse the items of list in place.\n\nReturn `true` on success, `false` on failure.\n\nThis is equivalent to `list.reverse()`.","ref":"Pythonx.C.PyList.html#reverse/1"},{"type":"function","title":"Pythonx.C.PyList.set_item/3","doc":"Set the item at index index in list to item. Return `true` on success.\n\nIf index is out of bounds, return `PyErr` with an `IndexError` exception.\n\nNote: This function \"steals\" a reference to item and discards a reference\nto an item already in the list at the affected position.","ref":"Pythonx.C.PyList.html#set_item/3"},{"type":"function","title":"Pythonx.C.PyList.set_slice/4","doc":"Set the slice of `list` between `low` and `high` to the contents of `itemlist`.\n\nAnalogous to `list[low:high] = itemlist`.\n\nThe `itemlist` may be `nil`, indicating the assignment of an empty list (slice deletion).\n\nReturn `true` on success, `false` on failure.\n\nIndexing from the end of the list is not supported.","ref":"Pythonx.C.PyList.html#set_slice/4"},{"type":"function","title":"Pythonx.C.PyList.size/1","doc":"Return the length of the list object in list; this is equivalent to len(list) on a list object.","ref":"Pythonx.C.PyList.html#size/1"},{"type":"function","title":"Pythonx.C.PyList.sort/1","doc":"Sort the items of list in place.\n\nReturn `true` on success, `false` on failure.\n\nThis is equivalent to `list.sort()`.","ref":"Pythonx.C.PyList.html#sort/1"},{"type":"module","title":"Pythonx.C.PyObject","doc":"Python Object","ref":"Pythonx.C.PyObject.html"},{"type":"function","title":"Pythonx.C.PyObject.ascii/1","doc":"As `repr/1`, compute a string representation of reference `o`,\nbut escape the non-ASCII characters in the string returned by `repr/1`\nwith `\\x`, `\\u` or `\\U` escapes.\n\nThis generates a string similar to that returned by `PyObject_Repr()` in Python 2.\nCalled by the `ascii()` built-in function.","ref":"Pythonx.C.PyObject.html#ascii/1"},{"type":"function","title":"Returns - Pythonx.C.PyObject.ascii/1","doc":"- reference to a new string representation object on success,\n- `PyErr` on failure,\n- `:error` only when it cannot allocate NIF resource for the object, for example, if the system is out of memory.","ref":"Pythonx.C.PyObject.html#ascii/1-returns"},{"type":"function","title":"Pythonx.C.PyObject.bytes/1","doc":"Compute a bytes representation of reference `o`.\n\nThis is the equivalent of the Python expression `bytes(o)`, when `o` is not an integer.\n\nUnlike `bytes(o)`, a `TypeError` is raised when `o` is an integer instead of a\nzero-initialized bytes object.","ref":"Pythonx.C.PyObject.html#bytes/1"},{"type":"function","title":"Returns - Pythonx.C.PyObject.bytes/1","doc":"- reference to a new bytes representation object on success,\n- `PyErr` on failure,\n- `:error` only when it cannot allocate NIF resource for the object, for example, if the system is out of memory.","ref":"Pythonx.C.PyObject.html#bytes/1-returns"},{"type":"function","title":"Pythonx.C.PyObject.decref/1","doc":"decrements the reference count for the object.","ref":"Pythonx.C.PyObject.html#decref/1"},{"type":"function","title":"Pythonx.C.PyObject.del_attr/2","doc":"Delete attribute named `attr_name`, for object `o`.\n\nReturns `false` on failure. This is the equivalent of the Python statement `del o.attr_name`.","ref":"Pythonx.C.PyObject.html#del_attr/2"},{"type":"function","title":"Pythonx.C.PyObject.del_attr_string/2","doc":"This is the same as `del_attr/2`, but `attr_name` is specified as a UTF-8 encoded bytes string, rather than a `PyObject`.","ref":"Pythonx.C.PyObject.html#del_attr_string/2"},{"type":"function","title":"Pythonx.C.PyObject.generic_get_attr/2","doc":"Generic attribute getter function that is meant to be put into a type object’s `tp_getattro` slot.\n\nIt looks for a descriptor in the dictionary of classes in the object’s MRO as well as an attribute in the object’s\n`__dict__` (if present). As outlined in Implementing Descriptors, data descriptors take preference over instance\nattributes, while non-data descriptors don’t. Otherwise, an `AttributeError` is raised.\n\nOnly returns `:error` if it cannot allocate NIF resource for the object,\nfor example, if the system is out of memory.","ref":"Pythonx.C.PyObject.html#generic_get_attr/2"},{"type":"function","title":"Pythonx.C.PyObject.generic_set_attr/3","doc":"Generic attribute setter and deleter function that is meant to be put into a type object’s `tp_setattro` slot.\n\nIt looks for a data descriptor in the dictionary of classes in the object’s MRO, and if found it takes\npreference over setting or deleting the attribute in the instance dictionary. Otherwise, the attribute is set\nor deleted in the object’s `__dict__` (if present).\n\nOn success, `true` is returned, otherwise an `AttributeError` is raised and `PyErr` is returned.","ref":"Pythonx.C.PyObject.html#generic_set_attr/3"},{"type":"function","title":"Pythonx.C.PyObject.get_attr/2","doc":"Retrieve an attribute named `attr_name` from object `o`.\n\nReturns the attribute value on success, or `nil` on failure.\n\nOnly returns `:error` if it cannot allocate NIF resource for the object,\nfor example, if the system is out of memory.\n\nThis is the equivalent of the Python expression `o.attr_name`.","ref":"Pythonx.C.PyObject.html#get_attr/2"},{"type":"function","title":"Pythonx.C.PyObject.get_attr_string/2","doc":"This is the same as `get_attr/2`, but `attr_name` is specified as a UTF-8 encoded bytes string, rather than a `PyObject`.","ref":"Pythonx.C.PyObject.html#get_attr_string/2"},{"type":"function","title":"Pythonx.C.PyObject.has_attr/2","doc":"Returns true if o has the attribute attr_name, and false otherwise.\n\nThis is equivalent to the Python expression hasattr(o, attr_name). This function always succeeds.","ref":"Pythonx.C.PyObject.html#has_attr/2"},{"type":"function","title":"Pythonx.C.PyObject.has_attr_string/2","doc":"This is the same as `has_attr/2`, but `attr_name` is specified as a UTF-8 encoded bytes string, rather than a `PyObject`.","ref":"Pythonx.C.PyObject.html#has_attr_string/2"},{"type":"function","title":"Pythonx.C.PyObject.incref/1","doc":"Increments the reference count for the object.","ref":"Pythonx.C.PyObject.html#incref/1"},{"type":"function","title":"Pythonx.C.PyObject.is_true/1","doc":"Returns `true` if the object `o` is considered to be `true`, and `false` otherwise.\n\nThis is equivalent to the Python expression `not not o`. On failure, return `:error`.","ref":"Pythonx.C.PyObject.html#is_true/1"},{"type":"function","title":"Pythonx.C.PyObject.length/1","doc":"Return the length of object `o`. If the object `o` provides either the sequence\nand mapping protocols, the sequence length is returned.\n\nOn error, `-1` is returned.\n\nThis is the equivalent to the Python expression `len(o)`.","ref":"Pythonx.C.PyObject.html#length/1"},{"type":"function","title":"Pythonx.C.PyObject.not/1","doc":"Returns `false` if the object `o` is considered to be `true`, and `true` otherwise.\nThis is equivalent to the Python expression `not o`. On failure, return `:error`.","ref":"Pythonx.C.PyObject.html#not/1"},{"type":"function","title":"Pythonx.C.PyObject.py_false/0","doc":"Returns a reference to the Python False object.\n\nOnly returns `:error` if it cannot allocate NIF resource for the object,\nfor example, if the system is out of memory.","ref":"Pythonx.C.PyObject.html#py_false/0"},{"type":"function","title":"Pythonx.C.PyObject.py_none/0","doc":"Returns a reference to the Python None object.\n\nOnly returns `:error` if it cannot allocate NIF resource for the object,\nfor example, if the system is out of memory.","ref":"Pythonx.C.PyObject.html#py_none/0"},{"type":"function","title":"Pythonx.C.PyObject.py_true/0","doc":"Returns a reference to the Python True object.\n\nOnly returns `:error` if it cannot allocate NIF resource for the object,\nfor example, if the system is out of memory.","ref":"Pythonx.C.PyObject.html#py_true/0"},{"type":"function","title":"Pythonx.C.PyObject.repr/1","doc":"Compute a string representation of reference `o`.\n\nThis is the equivalent of the Python expression `repr(o)`. Called by the `repr()` built-in function.","ref":"Pythonx.C.PyObject.html#repr/1"},{"type":"function","title":"Returns - Pythonx.C.PyObject.repr/1","doc":"- reference to a new string representation object on success,\n- `PyErr` on failure,\n- `:error` only when it cannot allocate NIF resource for the object, for example, if the system is out of memory.","ref":"Pythonx.C.PyObject.html#repr/1-returns"},{"type":"function","title":"Pythonx.C.PyObject.set_attr/3","doc":"Set the value of the attribute named `attr_name`, for object `o`, to the value `v`.\n\nReturns `PyErr` on failure; return `true` on success.\n\nThis is the equivalent of the Python statement `o.attr_name = v`.\n\nIf v is `nil`, the attribute is deleted. This behaviour is deprecated in favour of using `del_attr/2`,\nbut there are currently no plans to remove it.","ref":"Pythonx.C.PyObject.html#set_attr/3"},{"type":"function","title":"Pythonx.C.PyObject.set_attr_string/3","doc":"This is the same as `set_attr/3`, but `attr_name` is specified as a UTF-8 encoded bytes string, rather than a PyObject*.\n\nReturns `PyErr` on failure; return `true` on success.\n\nThis is the equivalent of the Python statement `o.attr_name = v`.\n\nIf v is `nil`, the attribute is deleted. This behaviour is deprecated in favour of using `del_attr/2`,\nbut there are currently no plans to remove it.","ref":"Pythonx.C.PyObject.html#set_attr_string/3"},{"type":"function","title":"Pythonx.C.PyObject.str/1","doc":"Compute a string representation of reference `o`.\n\nThis is the equivalent of the Python expression str(o). Called by the `str()` built-in function and,\ntherefore, by the `print()` function.","ref":"Pythonx.C.PyObject.html#str/1"},{"type":"function","title":"Returns - Pythonx.C.PyObject.str/1","doc":"- reference to a new string representation object on success,\n- `PyErr` on failure,\n- `:error` only when it cannot allocate NIF resource for the object, for example, if the system is out of memory.","ref":"Pythonx.C.PyObject.html#str/1-returns"},{"type":"function","title":"Pythonx.C.PyObject.type/1","doc":"Returns a type object corresponding to the object type of object `o`.\n\nWhen `o` is non-`NULL`, returns a type object corresponding to the object\ntype of object `o`.\n\nOn failure, returns `PyErr` with `SystemError`. This is equivalent to the Python expression `type(o)`.\n\nThis function creates a new strong reference to the return value.\n\nThere’s really no reason to use this function instead of the `Pythonx.C.type/1` function, which returns\na pointer of type `PyTypeObject*`, except when a new strong reference is needed.\n\nOnly returns `:error` if it cannot allocate NIF resource for the object,\nfor example, if the system is out of memory.","ref":"Pythonx.C.PyObject.html#type/1"},{"type":"type","title":"Pythonx.C.PyObject.borrowed/0","doc":"","ref":"Pythonx.C.PyObject.html#t:borrowed/0"},{"type":"type","title":"Pythonx.C.PyObject.t/0","doc":"","ref":"Pythonx.C.PyObject.html#t:t/0"},{"type":"module","title":"Pythonx.C.PyTuple","doc":"This subtype of PyObject represents a Python tuple object.","ref":"Pythonx.C.PyTuple.html"},{"type":"function","title":"Pythonx.C.PyTuple.check/1","doc":"Return `true` if `p` is a tuple object or an instance of a subtype of the tuple type.\n\nThis function always succeeds.","ref":"Pythonx.C.PyTuple.html#check/1"},{"type":"function","title":"Pythonx.C.PyTuple.check_exact/1","doc":"Return `true` if `p` is a tuple object, but not an instance of a subtype of the tuple type.\n\nThis function always succeeds.","ref":"Pythonx.C.PyTuple.html#check_exact/1"},{"type":"function","title":"Pythonx.C.PyTuple.get_item/2","doc":"Return the object at position `pos` in the tuple pointed to by `p`.\n\nIf `pos` is negative or out of bounds, return `PyErr` with an `IndexError` exception.\n\nThe returned reference is borrowed from the tuple `p` (that is: it is only valid as long\nas you hold a reference to `p`).\n\nTo get a strong reference, use `Pythonx.C.new_ref/1` or `Pythonx.C.PySequence.get_item/2`.","ref":"Pythonx.C.PyTuple.html#get_item/2"},{"type":"function","title":"Pythonx.C.PyTuple.get_slice/3","doc":"Return the slice of the tuple pointed to by `p` between `low` and `high`, or `PyErr` with an exception set on failure.\n\nThis is the equivalent of the Python expression `p[low:high]`.\n\nIndexing from the end of the tuple is not supported.","ref":"Pythonx.C.PyTuple.html#get_slice/3"},{"type":"function","title":"Pythonx.C.PyTuple.new/1","doc":"Return a new tuple object of size `len`, or `PyErr` with an exception set on failure.\n\nReturn value: New reference.","ref":"Pythonx.C.PyTuple.html#new/1"},{"type":"function","title":"Pythonx.C.PyTuple.size/1","doc":"Take a pointer to a tuple object, and return the size of that tuple. On error, return `PyErr` and with an exception set.","ref":"Pythonx.C.PyTuple.html#size/1"},{"type":"module","title":"Pythonx.C.PyUnicode","doc":"Unicode Objects","ref":"Pythonx.C.PyUnicode.html"},{"type":"function","title":"Pythonx.C.PyUnicode.as_utf8/1","doc":"Returns a reference to a Python Unicode object.","ref":"Pythonx.C.PyUnicode.html#as_utf8/1"},{"type":"function","title":"Pythonx.C.PyUnicode.from_string/1","doc":"Create a Unicode object from a UTF-8 encoded null-terminated char buffer str.","ref":"Pythonx.C.PyUnicode.html#from_string/1"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,49]}}